﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

using Mono.Cecil;
using Mono.Cecil.Cil;

class Program {
	const string OriginalDll = "HelloLibrary.dll";
	const string PatchedDll = "HelloLibraryPatched.dll";

	static void Main(string[] args) {
		//
		// Mono.Cecil & Mono.Cecil.Cil
		//

		AssemblyDefinition asmDef = AssemblyDefinition.ReadAssembly(OriginalDll);
		TypeDefinition typeDef = asmDef.MainModule.GetType("HelloString");
		MethodDefinition getItMethodDef = null;
		foreach (var m in typeDef.Methods) {
			if (m.Name == "GetIt") {
				getItMethodDef = m;
				break;
			}
		}

		if (getItMethodDef != null) {
			ILProcessor ilProc = getItMethodDef.Body.GetILProcessor();

			getItMethodDef.Body.Instructions.Clear();

			ilProc.Append(ilProc.Create(OpCodes.Ldstr, "No nazdar!"));
			ilProc.Append(ilProc.Create(OpCodes.Ret));

			asmDef.Write(PatchedDll);
		}

		//
		// System.Reflection
		//

		Console.Write("What to load (p = patched, o = original): ");
		string choice = Console.ReadLine();

		string asmName = choice == "p" ? PatchedDll : OriginalDll;

		Assembly a = Assembly.LoadFrom(asmName);
		IHelloProvider hp = (IHelloProvider) a.CreateInstance("HelloProvider");
		hp.SayHello();
	}
}

public interface IHelloProvider {
	void SayHello();
}

